const St = imports.gi.St;
const Main = imports.ui.main;

let corner_types = ['tl', 'tr', 'bl', 'br'];

let corners = {}; // List of corners displayed.
let radius = 16; // This also needs to be changed 3 places in the CSS.

function init() {}

function enable()
{
    let monitors = Main.layoutManager.monitors;

    for (let m in Main.layoutManager.monitors)
    { // Multi-monitor support. AFAIK it works but I can't actually test it for like 3 weeks.
        let monitor = monitors[m];

        for (let c in corner_types)
        {
            let corner = corner_types[c];

            corners[monitor.index+corner] = new St.Bin({
                style_class: 'corner'+corner, // Each corner gets a class to tie it to the corner it's in.
                reactive: false,
                can_focus: false, // I think all this says "Don't let me bother anyone" but I can't find any documentation anywhere.
                x_fill: true,
                y_fill: false,
                track_hover: false
            });
        }

        corners[monitor.index+'tl'].x = monitor.x; // Mark each corner with its position.
        corners[monitor.index+'tl'].y = monitor.y;

        corners[monitor.index+'tr'].x = monitor.x+monitor.width-radius;
        corners[monitor.index+'tr'].y = monitor.y;

        corners[monitor.index+'bl'].x = monitor.x;
        corners[monitor.index+'bl'].y = monitor.y+monitor.height-radius;

        corners[monitor.index+'br'].x = monitor.x+monitor.width-radius;
        corners[monitor.index+'br'].y = monitor.y+monitor.height-radius;
    }
    
    for (let c in corners)
    { // Activate the corners.
        Main.uiGroup.add_actor(corners[c]);
        corners[c].set_position(corners[c].x, corners[c].y);
    }
}

function disable() {
    for (let c in corners)
    { // Destroy the corners.
        corners[c].destroy();
    }
}